<template>
  <v-app>
    <v-layout justify-center style="margin-top:100px;">
      <v-flex xs10 md10 style="padding:60px;">
        <v-card class="mx-auto" elevation="1" style="height:auto;">
          <!-- ------------------------- โอนเงินไปยังผู้รับเงิน --------------------------- -->
          <v-container>
            <center>
              <h3 style="font-family: Sarabun, sans-serif;">
                ขั้นตอน 1 : การโอนเงินไปยังผู้รับเงิน
              </h3>
            </center>
            <br />
            <v-layout justify-center>
              <v-data-table
                :headers="headers"
                :items="data_directcredit"
                class="elevation-1 table-style"
                hide-actions
              >
                <template v-slot:items="props">
                  <tr>
                    <td class="text-xs-left">
                      {{ props.item.order_id }}
                    </td>

                    <td class="text-xs-center">
                      <div v-if="props.item.status_message == 'In process'">
                        <v-btn-toggle v-model="props.item.status_message">
                          <v-btn
                            @click="
                              callDirectCredit(props.item.payment_no, 'Success')
                            "
                            class="btn-completed"
                            :value="'Success'"
                            >Completed
                          </v-btn>
                          <v-btn
                            @click="
                              callDirectCredit(props.item.payment_no, 'Fail')
                            "
                            class="btn-rejected"
                            :value="'Fail'"
                            >Rejected
                          </v-btn>
                        </v-btn-toggle>
                      </div>

                      <div v-else>
                        <v-btn
                          v-if="props.item.status_message == 'Success'"
                          class="btn-completed"
                          disabled
                        >
                          Completed
                        </v-btn>
                        <v-btn
                          v-if="props.item.status_message == 'Fail'"
                          class="btn-rejected"
                          disabled
                        >
                          Rejected
                        </v-btn>
                      </div>
                    </td>
                  </tr>
                </template>
              </v-data-table>
            </v-layout>
            <v-layout justify-center>
              <v-btn @click="submitDirectCreditCallback()" class="btn-submit">
                Submit
              </v-btn>
            </v-layout>
          </v-container>
        </v-card>
      </v-flex>
    </v-layout>

    <v-footer>
      <span style="padding-left: 30px;font-family: Sarabun, sans-serif;"
        >© 2021 - ePayment Sandbox</span
      >
    </v-footer>
  </v-app>
</template>

<script>
import moment from "moment";
import Swal from "sweetalert2";

export default {
  data() {
    return {
      token: "",
      mobileView: false,
      headers: [
        { text: "หมายเลขรายการจ่ายเงิน", value: "order_id", sortable: false },
        {
          text: "สถานะ",
          value: "status_message",
          sortable: false,
          align: "center"
        }
      ],
      data_directcredit: [],
      direct_credit_result: [],
      data_orderid: [],
      datetime: new Date(),
      status_sandbox: this.$cookies.get("status_sandbox"),
      ewht: [],
      data_sandboxewht: []
    };
  },
  methods: {
    async getSandboxDirectCredit() {
      try {
        var { data } = await this.axios.post(
          `${process.env.VUE_APP_APIHOST}/sendbox/directcredit`,
          {
            data: this.data_orderid
          },
          {
            headers: { Authorization: this.token }
          }
        );
        if (data.status == "Success") {
          this.data_directcredit = data.data;
          console.log("this.data_directcredit", this.data_directcredit);

          // if (this.data_directcredit.length > 0) {
          //   for (
          //     let index = 0;
          //     index < this.data_directcredit.length;
          //     index++
          //   ) {
          //     const element = this.data_directcredit[index];

          //     if (element && element.status_message == "Success") {
          //       i = i + 1;
          //     }
          //     if (i == this.data_directcredit.length) {
          //       for (
          //         let index = 0;
          //         index < this.data_directcredit.length;
          //         index++
          //       ) {
          //         const _data = this.data_directcredit[index];

          //         if (_data) {
          //           this.data_sandboxewht.push(_data.payment_no);
          //         }
          //       }
          //       this.$cookies.set("status_sandbox", "receiver_ewht");
          //       this.$router.push({
          //         path: "/sandboxewht",
          //         query: { data: this.data_sandboxewht }
          //       });
          //     } else {
          //       this.$cookies.set("status_sandbox", "receiver_directcredit");
          //     }
          //   }
          // }
        } else {
          console.log(data);
        }
      } catch (error) {
        console.log(error.message);
      }
    },
    handleView() {
      this.mobileView = window.innerWidth <= 990;
    },
    callDirectCredit(_payment_no, _status) {
      let _code = "";
      if (_status == "Success") {
        _code = "1";
      } else if (_status == "Fail") {
        _code = "2";
      }

      let _data = {
        transaction_ref: _payment_no,
        trasfer_status_code: _code,
        trasfer_status_message: _status,
        transaction_date: moment(this.datetime).format("YYYYMMDD"),
        transaction_time: moment(this.datetime).format("HHmmss")
      };

      this.direct_credit_result.push(_data);
    },
    async submitDirectCreditCallback() {
      let cksubmit = "";
      for (let index = 0; index < this.data_directcredit.length; index++) {
        const element = this.data_directcredit[index];

        if (element && element.status_message == "In process") {
          cksubmit = false;
          alert("กรุณาเลือกสถานะให้ครบ");
          break;
        }
      }

      if (cksubmit !== false) {
        try {
          var { data } = await this.axios.post(
            `${process.env.VUE_APP_APIHOST}/directcredit/callback`,
            {
              direct_credit_result: this.direct_credit_result
            },
            {
              headers: { Authorization: this.token }
            }
          );

          if (data == "Success") {
            Swal.fire({
              title: "Completed",
              text: "",
              icon: "success",
              showConfirmButton: false,
              timer: 2500
            });
            setTimeout(() => {
              this.openSandboxEwht(this.direct_credit_result);
            }, 3000);
          }
        } catch (error) {
          console.log(error.message);
        }
      }
    },
    openSandboxEwht(data_result) {
      let pvno = [];
      if (data_result.length > 0) {
        for (let index = 0; index < data_result.length; index++) {
          const element = data_result[index];

          if (element && element.trasfer_status_message == "Success") {
            this.data_sandboxewht.push(element.transaction_ref);
          }
        }
        console.log("data_sandboxewht", this.data_sandboxewht);

        if (this.data_directcredit.length == this.data_sandboxewht.length) {
          // Case all completed
          close();
          let routeData = this.$router.resolve({
            name: "sandboxewht",
            query: { data: this.data_sandboxewht }
          });
          window.open(routeData.href, "_blank");
        } else {
          console.log("length: ", this.data_sandboxewht.length);
          if (this.data_sandboxewht.length > 0) {
            // Case completed and Rejected
            let routeData = this.$router.resolve({
              name: "sandboxewht",
              query: { data: this.data_sandboxewht }
            });
            window.open(routeData.href, "_blank");

            for (let i = 0; i < this.data_directcredit.length; i++) {
              const dt1 = this.data_directcredit[i];

              for (let j = 0; j < this.data_sandboxewht.length; j++) {
                const sb = this.data_sandboxewht[j];

                if (dt1.payment_no !== sb) {
                  pvno.push(dt1.order_id);
                }
              }
            }
            console.log("pvno", pvno);
          } else if (this.data_sandboxewht.length == 0) {
            // Case all Rejected
            for (let i = 0; i < this.data_directcredit.length; i++) {
              const dt2 = this.data_directcredit[i];
              if (dt2) {
                pvno.push(dt2.order_id);
              }
            }
            console.log("pvno", pvno);
          }

          Swal.fire({
            html:
              "กรุณาไปกด Resend ที่เมนูประวัติการทำรายการ<br\>หมายเลขรายการจ่ายเงิน: " +
              pvno,
            icon: "success"
          }).then(result => {
            Swal.fire({
              html:
                "หลังจากทำการ Resend เรียบร้อยแล้ว<br\>กรุณารีเฟรชหน้านี้อีกครั้ง"
            });
          });
        }
      }
    }
  },

  created() {
    this.handleView();

    if (this.$route.query) {
      if (typeof this.$route.query.data == "string") {
        let _data = {
          orderid: this.$route.query.data
        };
        this.data_orderid.push(_data);
      } else {
        for (let index = 0; index < this.$route.query.data.length; index++) {
          const element = this.$route.query.data[index];
          if (element) {
            let _data = {
              orderid: element
            };
            this.data_orderid.push(_data);
          }
        }
      }
      this.getSandboxDirectCredit();
    }
  }
};
</script>

<style scoped>
.btn-completed {
  font-weight: bold;
  line-height: 24px;
  text-align: center;
  color: #58a144 !important;
  border-radius: 4px;
  text-transform: none;
  background-color: #ecf8ea !important;
}

.btn-rejected {
  font-weight: bold;
  line-height: 24px;
  text-align: center;
  color: #d1392b !important;
  border-radius: 4px;
  text-transform: none;
  background-color: #fbe5e4 !important;
}

.btn-submit {
  margin-top: 30px;
  font-weight: bold;
  line-height: 24px;
  text-align: center;
  color: white !important;
  border-radius: 4px;
  text-transform: none;
  background-color: #58a144 !important;
  font-family: "Sarabun", sans-serif;
}
</style>
